## Prerequiresites
1. Install C# in your system following instructions [here](https://docs.microsoft.com/en-us/dotnet/core/install/linux-scripted-manual#scripted-install), multiple C# versions are provided, during this example, C# 3.1 is used.
   ```shell
   ./dotnet-install.sh -c 3.1
   ```
2. Verify C# installtion
   Once 
   ```text
   $dotnet --version
    3.1.409
   ```
3. Copy shared libraries from ons_csharp_sdk/lib/2.0.2/Linux/x86_64 to path where system loader searches, `/lib64` for example.
4. Update loader cache.
   ```shell
   sudo ldconfig
   ```
5. Verify your loader does find RocketMQ shared libraries
   ```
   ldconfig -v | grep rocketmq
   ```
   Desirable outputs are:
   ```text
   $sudo ldconfig -v | grep -E 'ONS|rocketmq'
   ldconfig: Can't stat /libx32: No such file or directory
   ldconfig: Path `/usr/lib' given more than once
   ldconfig: Path `/usr/lib64' given more than once
   ldconfig: Can't stat /usr/libx32: No such file or directory
        librocketmq_client_core.so -> librocketmq_client_core.so
        libONSClient4CPP.so -> libONSClient4CPP.so
   ```

## Run the sample
1. Substitue place-holders in `Program.cs`, lines involved are through 65 to 70.
2. Run
   ```shell
   cd sample1
   dotnet run
   ```
   You should see outputs similar to the following:
   ```text
   Use default log directory: /home/shutian.lzh/logs
   Log directory is: /home/shutian.lzh/logs
   send success 0B7A3255451918B4AAC2558F5D230000
   send success 0B7A3255451918B4AAC2558F61990003
   send success 0B7A3255451918B4AAC2558F65B50006
   send success 0B7A3255451918B4AAC2558F6A040009
   This is test message
   Receive message:0B7A3255451918B4AAC2558F65B50006
   send success 0B7A3255451918B4AAC2558F6E47000F
   This is test message
   Receive message:0B7A3255451918B4AAC2558F6E47000F
   send success 0B7A3255451918B4AAC2558F72630015
   This is test message
   Receive message:0B7A3255451918B4AAC2558F72630015
   ```